//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  if (OpenPictureDialog1->Execute()) {
    Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
    TrackBar1->Enabled=true;
    TrackBar1->Position=0;
    Button2->Enabled=true;
    SetBrightness();
  }
  else {
    TrackBar1->Enabled=false;
    Button2->Enabled=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetBrightness()
{
  int BrightnessIndex;
  int i,y,x,r,w,h;
  w=Image1->Picture->Bitmap->Width;
  h=Image1->Picture->Bitmap->Height;
  Image2->Picture->Bitmap->Width=w;
  Image2->Picture->Bitmap->Height=h;
  Image2->Picture->Assign(Image1->Picture);
  BrightnessIndex=TrackBar1->Position;
  for (int I=0; I <= 255; I++) {
    r = I + BrightnessIndex;
    if (r > 255)
      r =255;
    else if (r < 0)
      r = 0;
    ColorTable[I].R = r;
    ColorTable[I].G = r;
    ColorTable[I].B = r;
  }
  for (int Y = 0 ; Y <=h-1; Y++) {
    pRGB = (byte *)Image2->Picture->Bitmap->ScanLine[Y];
    int index=0;
    for (int X = 0 ; X <=w-1; X++) {
      pRGB[index] = ColorTable[pRGB[index]].R;
      pRGB[index+1] = ColorTable[pRGB[index+1]].G;
      pRGB[index+2] = ColorTable[pRGB[index+2]].B;
      index+=3;
    }
  }
}
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if (SavePictureDialog1->Execute())
    Image2->Picture->SaveToFile(SavePictureDialog1->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
  SetBrightness();
}
//---------------------------------------------------------------------------

