//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
//---------------------------------------------------------------------------
typedef struct TRGBColor_Type {
  byte R;
  byte G;
  byte B;
} TRGBColor;

class TForm1 : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TPanel *Panel2;
  TPanel *Panel3;
  TImage *Image1;
  TImage *Image2;
  TOpenPictureDialog *OpenPictureDialog1;
  TSavePictureDialog *SavePictureDialog1;
  TButton *Button1;
  TButton *Button2;
  TTrackBar *TrackBar1;
  TLabel *Label1;
  TLabel *Label2;
  void __fastcall Button1Click(TObject *Sender);
  void __fastcall Button2Click(TObject *Sender);
  void __fastcall TrackBar1Change(TObject *Sender);
private:	// User declarations
  TRGBColor ColorTable[255];
  Byte *pRGB;
  void __fastcall SetBrightness();
public:		// User declarations
  __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
